proc make-tracer {name outcmd} {
	proc $name [list status id val [list outcmd $outcmd] [list msg $name]] {
		$outcmd "$msg: [format {mesg = %x id = %d value = %d} $status $id $val]"
	}
}

proc midimap {{outcmd echo}} {
	make-tracer midi-note-on $outcmd
	make-tracer midi-note-off $outcmd
	make-tracer midi-cc $outcmd
}

proc midi-clock {} {}
proc midi-start {} {}

proc midi-program-change {status value {outcmd echo}} {
	$outcmd "midi-program-change; status = $status, value = $value"
}
proc midi-pitch-bend {status ivalue {outcmd echo}} {
	$outcmd "midi-pitch-bend, status = $status, value = $value, ivalue = $ivalue"
}

proc getval {min max amount} { ;# get interpolated value from min to max
	set amount [/ $amount 127.0]
	return [expr { (1 - $amount) * $min + $amount * $max }]
}

midimap
