;#
;# tcl script to read midi slider/knob values and control oscilloscope color
;#

proc getval {min max amount} { ;# get interpolated value from min to max
	set amount [/ $amount 127.0]
	return [expr { (1 - $amount) * $min + $amount * $max }]
}

proc change-color {which id value} {
	set chan [get-scope $which] ;# get current color of channel
	lset chan $id [getval 0 1 $value] ;# change color component ie r, g or b
	set-scope $which {*}$chan ;# set new channel color
	;# get-scope & set-scope are built in din commands to get and set oscilloscope color
}

proc midi-cc {status cc value} { ;# called when user operates sliders/knobs

	scoper $status $cc $value

}

proc scoper {status cc value} {

	if {$cc eq 1} {
		change-color left 0 $value ;# change left channel red
	}

	if {$cc eq 2} {
		change-color left 1 $value ;# change left channel green
	}

	if {$cc eq 3} {
		change-color left 2 $value ;# change left channel blue
	}

	if {$cc eq 4} {
		change-color right 0 $value ;# change right channel red
	}

	if {$cc eq 5} {
		change-color right 1 $value ;# change right channel green
	}

	if {$cc eq 6} {
		change-color right 2 $value ;# change right channel blue
	}

}
