proc getval {min max amount} { ;# get interpolated value
	set amount [/ $amount 127.0]
	return [expr { (1 - $amount) * $min + $amount * $max }]
}

proc midi_cc {status cc value} {
	
	if {$cc eq 2} {
			curve_value wave v 1 0.25 [getval 1 -1 $value]
			curve_value wave rt 0 0.05 [getval -2.6 2.6 $value]
			curve_value wave rt 2 0.8 [getval -1 2 $value]
			
	}

	if {$cc eq 3} {
			curve_value wave v 2 [getval 0.25 0.9 $value] [getval 1 -1 $value] 
	}
	
	if {$cc eq 4} {
		curve_value fm rt 1 0.5 [getval -5 5 $value]
		curve_value fm lt 2 0.5 [getval 5 -5 $value]
	}

	if {$cc eq 5} {
		curve_value gate-l lt 1 [getval 0 0.9 $value] [getval 0 1 $value]
		curve_value gate-r lt 1 [getval 0 0.9 $value] [getval 0 1 $value]
	}

	if {$cc eq 6} {
		curve_value gate-l rt 0 [getval 0 0.9 $value] [getval 0 1 $value]
		curve_value gate-r rt 0 [getval 0 0.9 $value] [getval 0 1 $value]
	}
		
	if {$cc eq 8} {
		curve_value feedback-l rt 0 0.4 [getval 0 0.95 $value]
		curve_value feedback-l lt 1 0.6 [getval 0 0.95 $value]
	}
	
	if {$cc eq 9} {
		curve_value feedback-r rt 0 0.4 [getval 0 0.95 $value]
		curve_value feedback-r lt 1 0.6 [getval 0 0.95 $value]
	}
	
}
