/*
 * This file is part of din.
 *
 * din is copyright (c) 2006 - 2011 S Jagannathan <jag@dinisnoise.org>
 * For more information, please visit http://dinisnoise.org
 *
 * din is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * din is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with din.  If not, see <http://www.gnu.org/licenses/>.
 *
*/
#ifndef __BEAT2VALUE
#define __BEAT2VALUE

#include "multi_curve.h"
#include "solver.h"
#include "listeners.h"
#include <string>
using namespace std;

struct beat2value {

	beat2value (const string& fname);
	~beat2value ();

	void operator! ();
	void operator() (float* result, int n);
	void operator() (float* out, float* result, int n, int d = 2);
	void modulate (float* out, float* result, int n, float amt);
	void modulate (float* out, float* result, int n, float* amt);

	string crvname;
	multi_curve crv;
	solver sol;
	xhandler *xmin, *xmax;
	void curve_edited ();

	bool enabled;

	string style;

	float bpm;
	void set_bpm (float n, int rst = 0);
	float get_bpm ();
	float now;
	float delta;

};

#endif
