/*
 * This file is part of din.
 *
 * din is copyright (c) 2006 - 2011 S Jagannathan <jag@dinisnoise.org>
 * For more information, please visit http://dinisnoise.org
 *
 * din is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * din is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with din.  If not, see <http://www.gnu.org/licenses/>.
 *
*/
#ifndef __textboard
#define __textboard

#include <vector>
#include <string>
#include "viewwin.h"
using namespace std;

struct text {
	string txt;
	int x, y;
	float r, g, b;
	text (const string& t, float xx, float yy, window& win, float rr=0.5, float gg=0.5, float bb=0.5) : txt(t), r(rr), g(gg), b(bb) {
		extern viewport view;
		win2view (xx, yy, x, y, win, view);
	}
};

struct textboard {
	vector<text> texts;
	void draw ();
	void add (const text& t) { texts.push_back (t);}
	void clear () { texts.clear ();}
};

#endif
