/*
 * This file is part of din.
 *
 * din is copyright (c) 2006 - 2011 S Jagannathan <jag@dinisnoise.org>
 * For more information, please visit http://dinisnoise.org
 *
 * din is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * din is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with din.  If not, see <http://www.gnu.org/licenses/>.
 *
*/
#include "delay.h"
#include "utils.h"
#include <string.h>
#include <stdlib.h>
#include <iostream>
#include "circler.h"

using namespace std;

void circler::zero () {
	nsamples = 0;
	samples = 0;
}

circler::circler (const string& sn) : 
fn (sn), crv (sn), sol (&crv), lis (this, &sol, samples)
{
	
	zero ();
	alloc (360);
	lis.edited (0);

}

circler::~circler () {
	if (samples) free (samples);
}


void circler::alloc (int n) {
	if (n > nsamples) {
		if (samples) free (samples);
		samples = (float *) calloc (n, sizeof (float));
	}
	nsamples = n;
}
