/*
 * This file is part of din.
 *
 * din is copyright (c) 2006 - 2011 S Jagannathan <jag@dinisnoise.org>
 * For more information, please visit http://dinisnoise.org
 *
 * din is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * din is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with din.  If not, see <http://www.gnu.org/licenses/>.
 *
*/
#include <textboard.h>
#include <SDL/SDL_opengl.h>
#include <font.h>

void textboard::draw () {
	glMatrixMode (GL_PROJECTION);
	glPushMatrix ();
	glLoadIdentity ();
	extern viewport view;
	glOrtho (0, view.xmax, 0, view.ymax, -1, 1);
	for (int i = 0, j = texts.size(); i < j; ++i) {
		text& t = texts[i];
		glColor3f (t.r, t.g, t.b);
		draw_string (t.txt, t.x, t.y);
	}
	glPopMatrix ();
}
